<?php /*
Plugin Name: AMP Opt-in Forms 
Plugin URI: http://ampforwp.com/optin-form
Description: Opt-in forms for AMP in WordPress. Most easiest and the best way to include opt-in forms in AMP
Version: 1.9.8
Author: AMPforWP Team
Author URI: http://ampforwp.com/
Donate link: https://www.paypal.me/Kaludi/5
License: GPL2
*/
// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;

define('AMP_OPTIN_DATA_VERSION', '1.9.8');
if ( ! defined( 'AMP_OPTIN_DATA_VERSION' ) ) {
  define( 'AMP_OPTIN_DATA_VERSION', '1.9.8');
}

// this is the URL our updater / license checker pings. This should be the URL of the site with EDD installed
define( 'AMP_OPTIN_DATA_STORE_URL', 'https://accounts.ampforwp.com/' );

// the name of your product. This should match the download name in EDD exactly
define( 'AMP_OPTIN_DATA_ITEM_NAME', 'Opt-in-Forms for AMP' );

// the download ID. This is the ID of your product in EDD and should match the download ID visible in your Downloads list (see example below)
//define( 'AMPFORWP_ITEM_ID', 2502 );
// the name of the settings page for the license input to be displayed
define( 'AMP_OPTIN_LICENSE_PAGE', 'opt-in-forms-for-amp' );
if(! defined('AMP_OPTIN_ITEM_FOLDER_NAME')){
    $folderName = basename(__DIR__);
    define( 'AMP_OPTIN_ITEM_FOLDER_NAME', $folderName );
}


// globals defiend below
define('AMPOPTIN_PLUGIN_DIR', trailingslashit( plugin_dir_path( __FILE__ ) ) );
define('AMPOPTIN_METABOX_DIR', trailingslashit( plugin_dir_path( __FILE__ ) . 'include/cmb2/' ) );
//*************************************//
// Plugin activation check starts here //
//*************************************//
include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
if ( is_plugin_active( 'accelerated-mobile-pages/accelerated-moblie-pages.php' ) ||is_plugin_active( 'amp/amp.php' )) {
add_filter( 'plugin_action_links', 'ampforwp_optin_settings_link', 10, 5 );

} else {
add_filter( 'plugin_action_links', 'ampforwp_optin_plugin_activation_link', 10, 5 );
// Return if Parent plugin is not active, and don't load the below code.
return;
}

#include redux
if(is_plugin_active( 'amp/amp.php' )){
          if ( !class_exists( 'ReduxFramework' ) ) {
              require_once dirname( __FILE__ ).'/include/extensions/loader.php';
              require_once dirname( __FILE__ ).'/include/redux-core/framework.php';
          }
          
        }

// Add Activate Parent Plugin button in settings page
function ampforwp_optin_plugin_activation_link( $actions, $plugin_file ) {
  static $plugin;
  if (!isset($plugin))
    $plugin = plugin_basename(__FILE__);
    if ($plugin == $plugin_file) {
        $settings = array('settings' => '<a href="plugin-install.php?s=accelerated+mobile+pages&tab=search&type=term">' . __('Please Activate the Parent Plugin.', 'ampforwp_optin') . '</a>');
        $actions = array_merge($settings , $actions );
      }
    return $actions;
}

// Add settings Icon in the plugin activation page
function ampforwp_optin_settings_link( $actions, $plugin_file )  {
  static $plugin;
  if (!isset($plugin))
    $plugin = plugin_basename(__FILE__);
    if ($plugin == $plugin_file) {
        $settings = array('settings' => '<a href="admin.php?page=amp_optin_options&tab=0">' . __('Settings', 'ampforwp_optin') . '</a>');
        $actions = array_merge( $actions , $settings);
      }
    return $actions;
}

//***********************************//
// Plugin activation check ends here //
//***********************************//

// all Post edit page related code here
require_once AMPOPTIN_PLUGIN_DIR . 'optin-post-type.php';


// Addign controls file for Metabox
require_once AMPOPTIN_PLUGIN_DIR . 'controls.php';

/*add_action('amp_post_template_head', 'ampforwp_optin_required_mustach_js');
function ampforwp_optin_required_mustach_js($amp_template) {
  $amp_mustache = $amp_template->amp_component_scripts;
 
    if ( empty($amp_mustache['amp-mustache']) && (is_singular() || is_home() )   ) { 

        $amp_mustache['amp-mustache']="https://cdn.ampproject.org/v0/amp-mustache-0.1.js";
         
    } 
   return $amp_mustache['amp-mustache'];    
}*/
add_filter('amp_post_template_data','amp_optin_form_script',11);
function amp_optin_form_script( $data ){

  if(empty($data['amp_component_scripts']['amp-form'])){
    $data['amp_component_scripts']['amp-form']='https://cdn.ampproject.org/v0/amp-form-0.1.js';
  }

  if(empty($data['amp_component_scripts']['amp-mustache'])){
    $data['amp_component_scripts']['amp-mustache']='https://cdn.ampproject.org/v0/amp-mustache-latest.js';
  } 

 return $data;
}

  function amp_optin_form_output( $atts ) {
    global $post;

    $atts[] = shortcode_atts( array(
        'src'  => $atts['id'],
    ), $atts );

    $form_class        = "";
    $form_class_output = "";

    if ( isset( $atts['class'] ) && $atts['class'] ) {
        $atts['class']    =  $atts['class'];
        $form_class       = $atts['class'];
    }
    $id                   = $atts['id'];
    $form_num             = get_post_meta( $atts['id'], 'amp_optin_select_form_company', true );
    $submit_button        = get_post_meta( $id, 'amp_option_submit_button_text', true);
    global $forms;

    switch ($form_num) {
                        case '1':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-1.php' );
                                    break;
                        case '2':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-2.php' );
                                    break;
                        case '3':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-3.php' );
                                    break;
                        case '4':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-4.php' );
                                    break;
                        case '5':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-5.php' );
                                    break;
                        case '6':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-6.php' );
                                    break;
                        case '7':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-7.php' );
                                    break;
                        case '8':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-8.php' );
                                    break;
                       case '9':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-9.php' );                            
                                    break;
                       case '10':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-10.php' );
                                    break;
                       case '11':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-11.php' );
                                    break;
                      case '12':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-12.php' );
                                    break;
                      case '13':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-13.php');
                                    break;
                      case '14':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-14.php');
                                    break;
                      case '15':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-15.php');
                                    break;

                      case '16':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-16.php');
                                    break;

                      case '17':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-17.php');
                                    break;
                      case '18':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-18.php');
                                    break;
                      case '19':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-19.php');
                                    break; 
                     case '20':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-20.php');
                                    break;
                    case '21':
                                    require_once(AMPOPTIN_PLUGIN_DIR .'forms/form-21.php');
                                    break;
                    case '22':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-22.php' ); 
                                    break;

                    case '23':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-23.php' ); 
                                    break; 
                    case '24':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-24.php' ); 
                                    break;  
                    case '25':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-25.php' ); 
                                    break;  
                    case '26':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-26.php' ); 
                                    break;              
    }

    if ( $form_class ) {
      $form_class_output  = $form_class;
    }

    if($form_num){
      $amp_optin_data = 'amp_optin_form_'. $form_num; 
      $output = '<div class="amp-optin-form-wrapper form-'. $form_num .' '. $form_class_output .' optin-'. $atts['id'] .'">';
      $output .= $amp_optin_data($id);
      $output .= '</div>';
      #out optin form with AMP(official) plugin
      if( function_exists('ampforwp_is_amp_endpoint') && ampforwp_is_amp_endpoint()||
          function_exists('amp_activate') && function_exists( 'is_amp_endpoint' ) && is_amp_endpoint() ){
        return $output;
      }
    }
    return '';
}



if(function_exists('amp_activate')){
remove_filter( 'amp_content_sanitizers', 'ampforwp_custom_form_sanitizer', 20);
}
if( function_exists('ampforwp_is_amp_endpoint') ){
add_filter( 'amp_content_sanitizers', 'ampforwp_custom_form_sanitizer', 20); 
}
add_filter( 'ampforwp_content_sanitizers', 'ampforwp_custom_form_sanitizer', 20);
function ampforwp_custom_form_sanitizer( $sanitizer_classes ) {
  require_once( AMPOPTIN_PLUGIN_DIR .  'class/class-blacklist-sanitizer.php');
    unset( $sanitizer_classes[ 'AMP_Blacklist_Sanitizer' ] );
  $sanitizer_classes[ 'AMPFORWP_Blacklist_Sanitizer' ] = array();
  return $sanitizer_classes;
}


// Generating Short code for Optin
function amp_optin_shortcode() {
  add_shortcode('amp-optin', 'amp_optin_form_output');
}
add_action( 'init', 'amp_optin_shortcode');

// optin styling for standard & transitional mode.
if(function_exists('amp_activate') || is_plugin_active('amp/amp.php')){
  $getOption = get_option('amp-options');
  if ( $getOption['theme_support'] == 'standard' || $getOption['theme_support'] == 'transitional'){
  
   add_action('wp_head', 'amp_modal_optin_styling');
  }

  function amp_modal_optin_styling(){
    ob_start();
    ampforwp_option_styling();
    $ob = ob_get_contents();
    ob_get_clean();
    echo'<style>'.$ob.'</style>';
  }
}

// optin styling
add_action('amp_post_template_css','ampforwp_option_styling',20 );
function ampforwp_option_styling() { global $redux_builder_amp; ?>
.amp-optin-form-wrapper fieldset{border:0;margin:0;padding:0}
.amp-optin-form-wrapper .optin-headline-title{font-size: 20px; margin: 0; color:<?php echo $redux_builder_amp['amp_option_form_headline_color']['color'] ?>}
select#mce-MMERGE9-tov {
    display: none;
}
select.mailmunchselect {appearance: none;font-size: 14px;padding: 8px;width: 100%;border: 1px solid rgba(0,0,0,.13);
}
.submit_message p.show {font-size: 18px;}
.amp-optin-form-wrapper p{font-size: 13px; margin: 4px 0 8px 0;line-height: 18px;color:<?php echo $redux_builder_amp['amp_option_form_text_color']['color'] ?>;}
.amp-optin-form-wrapper{width: 300px;margin: 0 auto 15px auto;padding: 20px 25px; background-color: <?php echo $redux_builder_amp['amp_option_form_bg_color']['color'] ?>;color:<?php echo $redux_builder_amp['amp_option_form_text_color']['color'] ?>;}
.amp-optin-form-wrapper .form-submit{background-color: <?php echo $redux_builder_amp['amp_option_button_bg_color']['color'] ?>; color: <?php echo $redux_builder_amp['amp_option_button_text_color']['color'] ?>;padding: 10px;width: 100%;border: 0;border-radius: 60px;margin:5px 0px 0px 0px}
.amp-optin-form-wrapper #sg-form-button{background-color: <?php echo $redux_builder_amp['amp_option_button_bg_color']['color'] ?>; color: <?php echo $redux_builder_amp['amp_option_button_text_color']['color'] ?>;padding: 10px;width: 100%;border: 0;border-radius: 60px;margin:5px 0px 0px 0px}
.amp-optin-form-wrapper label{width: 100%;display: inline-block;}
.amp-optin-form-wrapper input{padding: 10px;width: 100%;margin: 3px 0px;font-size:13px;border: 1px solid rgba(0, 0, 0, 0.13)}
html { -webkit-box-sizing: border-box; -moz-box-sizing: border-box; box-sizing: border-box;}
*, *:before, *:after { -webkit-box-sizing: inherit; -moz-box-sizing: inherit; box-sizing: inherit;
  }
.amp-optin-form-wrapper.form-8 { margin: 0 auto 0px auto; padding: 20px 0px; }
.amp-optin-form-wrapper.form-8 .optin-msg { text-align: center; }
.form-16 .optin-msg { text-align: center; }
.form-18 .optin-msg { text-align: center; }
.amp-optin-form-wrapper.form-18 { margin: 0 auto 0px auto; padding: 20px 0px; }   
@keyframes Pop-up-delay {
  to {
    visibility: visible;
  }
}
body #my-notification.amp-active { background: hsla(0, 2%, 14%, 0.7); border-color: #242323b3; z-index: 10000; height: -webkit-fill-available; height: -moz-fill-available; top:0; visibility: hidden; animation: 0s linear <?php if( isset($redux_builder_amp['ampforwp-optin-popup-sec']) && $redux_builder_amp['ampforwp-optin-popup-sec']) { echo $redux_builder_amp['ampforwp-optin-popup-sec']; } else {?> 3s <?php } ?> forwards Pop-up-delay;
}
.optin-popup { position: fixed; -webkit-overflow-scrolling: touch; top: 0; right: 0; bottom: 0; left: 0; padding: 1rem; display: flex; align-items: center; justify-content: center; }
.pop-up-form { position: relative; }
.ampforwp-pop-up-close-btn { background-color: #525252; border: 1px solid #525252; top: 0; position: absolute; font-size: 12px; padding: 7px 13px; right: 0; }
.optin-msg amp-img { max-width: 100%; }
.ampforwp_type_hidden_form_15 { display:none; }
#my-lightbox { z-index: 10000; }
.lightbox { background: rgba(0,0,0,0.5);width: 100%;height: 100%;position: absolute;text-align: center;top: 0;align-items: center;justify-content: center;display: flex; }
.setUpForm { position: relative; }
button.lightClick {
    background: <?php echo $redux_builder_amp['amp-optin-modal-button-bg-color']['color']; ?>;
    border: 1px solid <?php echo $redux_builder_amp['amp-optin-modal-button-bg-color']['color']; ?>;
    min-height: 40px;
    line-height: 40px;
    color: <?php echo $redux_builder_amp['amp-optin-modal-button-text-color']['color']; ?>;
    font-size: 20px;
    <?php if(isset($redux_builder_amp['ampforwp-optin-modal-button-position']) && $redux_builder_amp['ampforwp-optin-modal-button-position'] == 1 ) { ?>
           transform: rotate(90deg);left: 0;margin-left: -48px;margin-top: 200px;
    <?php } 
          elseif (isset($redux_builder_amp['ampforwp-optin-modal-button-position']) && $redux_builder_amp['ampforwp-optin-modal-button-position'] == 2  ) { 
            ?>
              transform: rotate(0deg);bottom: 0px;left: 0;margin-bottom: 0px;margin-top: 0px;
    <?php  } 
          elseif (isset($redux_builder_amp['ampforwp-optin-modal-button-position']) && $redux_builder_amp['ampforwp-optin-modal-button-position'] == 3) { ?>
               transform: rotate(90deg);right: 0;margin-right: -48px;margin-top: 200px;
    <?php }
          elseif (isset($redux_builder_amp['ampforwp-optin-modal-button-position']) && $redux_builder_amp['ampforwp-optin-modal-button-position'] == 4) { ?>
              transform: rotate(0deg);bottom: 0px;right: 0;margin-bottom: 0px;margin-top: 0px;
   <?php } ?>
    position: fixed;text-transform:uppercase;cursor:pointer;z-index: 9999; font-weight: bold;
}
.cansle {top: 0;position: absolute;font-size: 12px;padding: 7px 13px;right: 0;background-color: #525252;border: 1px solid #525252;font-family: sans-serif;cursor: pointer; } 
.ampforwp_ajax_loading_msg{ display:none; }
.ampforwp_ajax_loading_msg p{text-align: center;margin: 0;font-size: 100%;}form.amp-form-submitting .ampforwp_ajax_loading_msg{display:block;}
.amp-form-submit-success span.optin-headline-title, .amp-form-submit-success input.user-valid.valid, .amp-form-submit-success .dropdown-field-wrapper{
  display: none;
}
<?php 

  if(function_exists('amp_activate') && isset($redux_builder_amp['ampforwp-optin-modal-button-position']) && $redux_builder_amp['ampforwp-optin-modal-button-position'] == 1 || isset($redux_builder_amp['ampforwp-optin-modal-button-position']) && $redux_builder_amp['ampforwp-optin-modal-button-position'] == 3){?>

  button.lightClick{top:0px;}
<?php } ?>

<?php }
//**********************************************//
// AMP optin COntent manipulation Code Start here //
//**********************************************//

  function get_amp_optin_form_output( $atts ) {
      global $post;

      $atts[] = shortcode_atts( array(
          'src' => $atts['id'],
      ), $atts ); 

      $form_class        = "";
      $form_class_output = "";
      if ( isset( $atts['class'] ) && $atts['class'] ) {
          $atts['class']    =  $atts['class'];
          $form_class       =  $atts['class'];
      }

      $id                = $atts['id'];
      $form_num          = get_post_meta( $atts['id'], 'amp_optin_select_form_company', true );
      $submit_button     = get_post_meta( $id, 'amp_option_submit_button_text', true);

      global $forms;
      switch ($form_num) {
                          case '1':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-1.php' );
                                      break;
                          case '2':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-2.php' );
                                      break;
                          case '3':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-3.php' );
                                      break;
                          case '4':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-4.php' );
                                      break;
                          case '5':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-5.php' );
                                      break;
                          case '6':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-6.php' );
                                      break;
                          case '7':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-7.php' );
                                      break;
                          case '8':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-8.php' );
                                      break;
                          case '9':
                                      require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-9.php' );
                                      break; 
                          case '10':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-10.php' );
                                    break;   
                          case '11':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-11.php' ); 
                                    break;
                          case '12':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-12.php' );
                                    break;
                                                              break; 
                          case '13':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-13.php' );
                                    break;
                          case '14':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-14.php' );
                                    break; 
                          case '15':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-15.php' );
                                    break;
                         case '16':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-16.php' );
                                    break;  
                         case '17':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-17.php' );
                                    break;
                         case '18':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-18.php' ); 
                                    break;
                         case '19':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-19.php' ); 
                                    break;   
                         case '20':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-20.php' ); 
                                    break;
                        case '21':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-21.php' ); 
                                    break;
                        case '22':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-22.php' ); 
                                    break;

                        case '23':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-23.php' ); 
                                    break;  
                        case '24':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-24.php' ); 
                                    break;
                        case '25':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-25.php' ); 
                                    break;
                        case '26':
                                    require_once( AMPOPTIN_PLUGIN_DIR . 'forms/form-26.php' ); 
                                    break;                        
      }

      if ( $form_class ) {
         $form_class_output  = $form_class;
      }

      if($form_num){
        $amp_optin_data = 'amp_optin_form_'. $form_num; 
        $output = '<div class="amp-optin-form-wrapper form-'. $form_num .' '. $form_class_output .' optin-'. $atts['id'] .'">';
        $output .= $amp_optin_data($id);
        $output .= '</div>';
        return $output;
      }
      return '';
  }


  add_action( 'pre_amp_render_post','ampforwp_optin_content_manipulation');
  function ampforwp_optin_content_manipulation() {
    add_filter( 'the_content', 'ampforwp_content_optin_insertion_top', 15 );
    add_filter( 'the_content', 'ampforwp_content_optin_insertion_bottom', 14 );
  }

  function ampforwp_content_optin_insertion_top( $content ) {
    global $redux_builder_amp;
    $id = $redux_builder_amp['ampforwp-optin-box-selected-optin'];
    $arg = array( 'id' => $id ); 
    $cont = get_amp_optin_form_output( $arg );
    $is_post_type = $is_page_type = $is_product_type = '';
    
      if( isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('product',$redux_builder_amp['amp-opt-in-posttype-support'])){
        if(function_exists('is_product')){
        $is_product_type = is_product();
      }
    }
    if( isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('post',$redux_builder_amp['amp-opt-in-posttype-support'])){
          if(function_exists('is_product')){
        $is_post_type = (is_single() && !is_product());
        }else{
        $is_post_type = is_single();
       }
    }

    if(isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('page',$redux_builder_amp['amp-opt-in-posttype-support'])){
      $is_page_type = is_page();
    }
    /*if(isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('category', $redux_builder_amp['amp-opt-in-posttype-support']) ){
      $category = is_category();
    }*/

    if( $redux_builder_amp['ampforwp-optin-box-content-top'] && $redux_builder_amp['ampforwp-optin-box-position'] ){
      if( $is_post_type || $is_page_type || $is_product_type ){
      $content = $cont . '  ' . $content ;
     }
    }
    return $content;
  
  }

  function ampforwp_content_optin_insertion_bottom( $content ) {
    global $redux_builder_amp;
    $id = $redux_builder_amp['ampforwp-optin-box-selected-optin'];
    $arg = array( 'id' => $id );
    $cont = get_amp_optin_form_output( $arg );
    $is_post_type = $is_page_type = $is_product_type = '';
    
      if( isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('product',$redux_builder_amp['amp-opt-in-posttype-support'])){
        if(function_exists('is_product')){
        $is_product_type = is_product();
      }
    }
    if( isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('post',$redux_builder_amp['amp-opt-in-posttype-support'])){
          if(function_exists('is_product')){
        $is_post_type = (is_single() && !is_product());
        }else{
        $is_post_type = is_single();
       }
    }

    if(isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('page',$redux_builder_amp['amp-opt-in-posttype-support'])){
      $is_page_type = is_page();
    }
    /*if(isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('category', $redux_builder_amp['amp-opt-in-posttype-support']) ){
      $category = is_category();
    }*/

    if( $redux_builder_amp['ampforwp-optin-box-content-bottom'] && $redux_builder_amp['ampforwp-optin-box-position'] ){
        if( $is_post_type || $is_page_type || $is_product_type ){
      $content = $content . '  '. $cont;
    }
  }
    return $content;
  }


add_action( 'pre_amp_render_post', 'ampforwp_incontent_optin_code' );
if ( ! function_exists( 'ampforwp_incontent_optin_code' ) ) {
  function ampforwp_incontent_optin_code() {
    global $redux_builder_amp;
    $is_post_type = $is_page_type = $is_product_type = '';
    
      if( isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('product',$redux_builder_amp['amp-opt-in-posttype-support'])){
        if(function_exists('is_product')){
        $is_product_type = is_product();
      }
    }
    if( isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('post',$redux_builder_amp['amp-opt-in-posttype-support'])){
        if(function_exists('is_product')){
        $is_post_type = (is_single() && !is_product());
        }else{
        $is_post_type = is_single();
       }
    }

    if(isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('page',$redux_builder_amp['amp-opt-in-posttype-support'])){
      $is_page_type = is_page();
    }
    /*if(isset($redux_builder_amp['amp-opt-in-posttype-support']) && in_array('category', $redux_builder_amp['amp-opt-in-posttype-support']) ){
      $category = is_category();     
    }*/
    if($redux_builder_amp['ampforwp-optin-box-content'] && $redux_builder_amp['ampforwp-optin-box-position'] ) {

      if( $is_post_type || $is_page_type || $is_product_type ){
      add_filter( 'the_content', 'ampforwp_insert_incontent_optin_code' );
    }
    }
  }
}

if ( ! function_exists( 'ampforwp_insert_incontent_optin_code' ) ) {
  function ampforwp_insert_incontent_optin_code( $content ) {
    global $redux_builder_amp;
    $arg = array( 'id' => $redux_builder_amp['ampforwp-optin-box-selected-optin'] );
    $insertion = get_amp_optin_form_output($arg);

    // to show optin after below number of paragraph.
    $paragraph_id = '50-percent';
    if ( ( is_single() || is_page() || is_front_page() )  && ! is_admin() ) {
      return ampforwp_insert_after_paragraph_optin_code( $insertion, $paragraph_id, $content );
    }
    return $content;
  }
}

add_action('pre_amp_render_post', 'exclude_optin_from_spec_post', 9);
function exclude_optin_from_spec_post() {
    global $post, $redux_builder_amp;

    $exclude_post_id = (array) $redux_builder_amp['ampforwp-exclude-optin-box-for-spec-post'];
    $exclude_post_id = explode(',', $exclude_post_id[0]);
    $exclude_page_id = (array) $redux_builder_amp['ampforwp-exclude-optin-box-for-spec-page'];
    $exclude_page_id = explode(',', $exclude_page_id[0]);

    $exclude_id = array_merge( $exclude_post_id, $exclude_page_id );
    
    if (in_array($post->ID, $exclude_id  )) {
        remove_action( 'pre_amp_render_post','ampforwp_optin_content_manipulation');
        remove_action( 'pre_amp_render_post', 'ampforwp_incontent_optin_code' );
     }
}


// Parent Function that makes the magic happen
if ( ! function_exists( 'ampforwp_insert_after_paragraph_optin_code' ) ) {
  function ampforwp_insert_after_paragraph_optin_code( $insertion, $paragraph_id, $content ) {
    global $redux_builder_amp;
    $closing_p = '</p>';
    $paragraphs = explode( $closing_p, $content );
// var_dump($paragraphs);
    if ( $paragraph_id == '50-percent' ) {
      $paragraph_id =  count($paragraphs);
      $paragraph_id = $paragraph_id / 2 ;
      $paragraph_id = round($paragraph_id);
    }

    foreach ($paragraphs as $index => $paragraph) {
      if ( trim( $paragraph ) ) {
        $paragraphs[$index] .= $closing_p;
      }
      if ( $paragraph_id == $index + 1 ) {
        $paragraphs[$index] .= $insertion;
      }
    }
    return implode( '', $paragraphs );
  }
}
#pop-up for AMP by automatic plugin
 
if(is_plugin_active('amp/amp.php')){
  add_action('amp_post_template_footer','ampforwp_optin_popup');
  if( ! function_exists('ampforwp_optin_popup') ){
  function ampforwp_optin_popup() {
      global $redux_builder_amp;
              if( isset($redux_builder_amp['ampforwp-optin-form-popup']) && $redux_builder_amp['ampforwp-optin-form-popup'] ){
       ?>
    <amp-user-notification id="my-notification"
  layout="nodisplay">
      <div class="optin-popup"> 
    <?php  global $redux_builder_amp; 
            $id = $redux_builder_amp['ampforwp-optin-popup-selected-optin'];
            $arg = array( 'id' => $id ); 
            $pop_up_cont = get_amp_optin_form_output( $arg );
           ?>
              <div class ="pop-up-form"><?php
             echo $pop_up_cont;?><button on="tap:my-notification.dismiss"
      class="ampforwp-pop-up-close-btn">X</button> </div>
  
    </div>
  </amp-user-notification>
<?php } } } }

// opt-in Modal Feature for amp.

if(is_plugin_active('amp/amp.php')){
   $getOption = get_option('amp-options');
   $getamp = filter_input(INPUT_SERVER, 'REQUEST_URI');
   $amp  = explode('/', $getamp);
  if ( $getOption['theme_support'] == 'standard' || $getOption['theme_support'] == 'transitional' && in_array('?amp', $amp)){
   add_filter('wp_footer', 'ampforwp_optin_modal_for_amp');
  }else{
   add_action('amp_post_template_footer','ampforwp_optin_modal_for_amp');

  }
}

if(!function_exists('ampforwp_optin_modal_for_amp')) { 
  function ampforwp_optin_modal_for_amp(){  
    global $redux_builder_amp;
    if( isset($redux_builder_amp['ampforwp-optin-modal-form']) && $redux_builder_amp['ampforwp-optin-modal-form'] == 1 ){?>

      <button class="lightClick" on="tap:my-lightbox"
       role="button"
       tabindex="0">

      <?php 
        $modal_btn_text =  $redux_builder_amp['ampforwp-optin-modal-button-text']; 
            echo $modal_btn_text; 
      ?>
    </button>  
    <amp-lightbox id="my-lightbox" layout="nodisplay">
      <div class="lightbox">  
         <?php   
          global $redux_builder_amp;
          $id = $redux_builder_amp['ampforwp-optin-modal-optin-select'];
          $arg = array( 'id' => $id ); 
          $modal_cont = get_amp_optin_form_output( $arg ); ?>
          <div class="setUpForm">
            <?php echo $modal_cont; ?>
           <button class="cansle" on="tap:my-lightbox.close" role="button" tabindex="0">X</button>
         </div>
      </div>
    </amp-lightbox>
  <?php 
  }
 }
  
}

// Pop-up Feature
if( isset($redux_builder_amp['ampforwp-optin-form-popup']) && $redux_builder_amp['ampforwp-optin-form-popup'] == 1){
  add_action('ampforwp_body_beginning','ampforwp_optin_popup');
  if( ! function_exists('ampforwp_optin_popup') ){
  function ampforwp_optin_popup() {
      global $redux_builder_amp; ?>
    <amp-user-notification id="my-notification"
  layout="nodisplay">
      <div class="optin-popup"> 
    <?php 
            global $redux_builder_amp;
            $id = $redux_builder_amp['ampforwp-optin-popup-selected-optin'];
            $arg = array( 'id' => $id ); 
            $pop_up_cont = get_amp_optin_form_output( $arg );

            if( isset($redux_builder_amp['ampforwp-optin-form-popup']) && $redux_builder_amp['ampforwp-optin-form-popup'] ){ ?>
              <div class ="pop-up-form"> <?php
                  // echo $pop_up_cont; 
        $sanitizer_obj = new AMPFORWP_Content( $pop_up_cont, array(), apply_filters( 'ampforwp_content_sanitizers', array( 
          'AMP_Img_Sanitizer' => array(), 
          'AMP_Style_Sanitizer' => array(),
          'AMP_Iframe_Sanitizer' => array(
             'add_placeholder' => true,
           ), 
        ) 
      ) );
        $sanitized_pop_up =  $sanitizer_obj->get_amp_content();
        echo $sanitized_pop_up;
                  ?>  <button on="tap:my-notification.dismiss"
      class="ampforwp-pop-up-close-btn">X</button> </div> <?php
            }
    ?>  
    </div>
  </amp-user-notification>
<?php } } }
// adding amp-user-notification script for pop-up feature
add_filter( 'amp_post_template_data', 'ampforwp_pop_up_notification_scripts', 75 );
function ampforwp_pop_up_notification_scripts( $data ) {
  global $redux_builder_amp;

  if ( isset($redux_builder_amp['ampforwp-optin-form-popup']) && $redux_builder_amp['ampforwp-optin-form-popup'] == true ) {
          if ( empty( $data['amp_component_scripts']['amp-user-notification'] ) ) {
            $data['amp_component_scripts']['amp-user-notification'] = 'https://cdn.ampproject.org/v0/amp-user-notification-0.1.js';
          }
          if ( empty( $data['amp_component_scripts']['amp-iframe'] ) ) {
          $data['amp_component_scripts']['amp-iframe'] = 'https://cdn.ampproject.org/v0/amp-iframe-0.1.js';
          }
  }  
  return $data;
}

// opt-in module for pb

add_filter('ampforwp_pagebuilder_modules_filter', 'ampforwp_module_templates_opt_in_pb');
if(!function_exists("ampforwp_module_templates_opt_in_pb")){
  function ampforwp_module_templates_opt_in_pb($moduleTemplate){
     
    global $moduleTemplate;
        $dir = ABSPATH . 'wp-content/plugins/amp-optin/';    

    if (is_dir($dir)) {
        if ($dh = opendir($dir)) {
            while (($file = readdir($dh)) !== false) {
              if(is_file($dir.$file) && strpos($file, '-pb-module.php') == true){
                $moduleTemplate[str_replace("-pb-module.php", "", $file)] = include $dir.$file;
              }
            } 
            closedir($dh);
        }
    }     
   return $moduleTemplate;    
  }
}

// opt-in Modal Feature

if( isset($redux_builder_amp['ampforwp-optin-modal-form']) && $redux_builder_amp['ampforwp-optin-modal-form'] == 1 ){
add_action('ampforwp_body_beginning','ampforwp_optin_modal');
if(!function_exists('ampforwp_optin_modal')) { 
  function ampforwp_optin_modal(){  global $redux_builder_amp;
    ?>
    <button class="lightClick" on="tap:my-lightbox"
     role="button"
     tabindex="0">
    <?php $modal_btn_text =  $redux_builder_amp['ampforwp-optin-modal-button-text']; 
          echo $modal_btn_text; ?>
  </button>  
  <amp-lightbox id="my-lightbox"
     layout="nodisplay">
    <div class="lightbox">  
       <?php   
        global $redux_builder_amp;
        $id = $redux_builder_amp['ampforwp-optin-modal-optin-select'];
        $arg = array( 'id' => $id ); 
        $modal_cont = get_amp_optin_form_output( $arg ); ?>
        <div class="setUpForm">   <?php      
        $sanitizer_modal_obj = new AMPFORWP_Content( $modal_cont, array(), apply_filters( 'ampforwp_content_sanitizers', array( 
                        'AMP_Img_Sanitizer' => array(), 
                        'AMP_Style_Sanitizer' => array(),
                        'AMP_Iframe_Sanitizer' => array(
                           'add_placeholder' => true,
                             ), 
                         ) 
                      ) 
        );
        $sanitized_modal_optin =  $sanitizer_modal_obj->get_amp_content();
        echo $sanitized_modal_optin;
      ?>
       <button class="cansle" on="tap:my-lightbox.close"
       role="button"
       tabindex="0">X</button> </div>
    </div>
  </amp-lightbox>

  <?php }
  }
}

// Optin with AMP CTA Bar 

if( isset($redux_builder_amp['ampforwp-cta-bar-with-amp-optin']) && $redux_builder_amp['ampforwp-cta-bar-with-amp-optin'] == 1 ){
add_action('ampforwp_body_beginning','ampforwp_optin_with_cta');
if(!function_exists('ampforwp_optin_with_cta')) { 
  function ampforwp_optin_with_cta(){  global $redux_builder_amp;
    ?> 
  <amp-lightbox id="cta-optin-lightbox"
     layout="nodisplay">
    <div class="lightbox">  
       <?php   
        global $redux_builder_amp;
        $id = $redux_builder_amp['ampforwp-cta-bar-with-amp-optin-select'];
        $arg = array( 'id' => $id ); 
        $modal_cont = get_amp_optin_form_output( $arg ); ?>
        <div class="setUpForm">   <?php      
        $sanitizer_modal_obj = new AMPFORWP_Content( $modal_cont, array(), apply_filters( 'ampforwp_content_sanitizers', array( 
                        'AMP_Img_Sanitizer' => array(), 
                        'AMP_Style_Sanitizer' => array(),
                        'AMP_Iframe_Sanitizer' => array(
                           'add_placeholder' => true,
                             ), 
                         ) 
                      ) 
        );
        $sanitized_modal_optin =  $sanitizer_modal_obj->get_amp_content();
        echo $sanitized_modal_optin;
      ?>
       <button class="cansle" on="tap:cta-optin-lightbox.close"
       role="button"
       tabindex="0">X</button> </div>
    </div>
  </amp-lightbox>

  <?php }
  }
}

add_filter( 'amp_post_template_data', 'ampforwp_optin_modal_lightbox_scripts' );
function ampforwp_optin_modal_lightbox_scripts( $data ) {
  global $redux_builder_amp;
if ( (isset($redux_builder_amp['ampforwp-optin-modal-form']) && $redux_builder_amp['ampforwp-optin-modal-form'] == true) || (isset($redux_builder_amp['ampforwp-cta-bar-with-amp-optin']) && $redux_builder_amp['ampforwp-cta-bar-with-amp-optin'] == true) ) {
          if ( empty( $data['amp_component_scripts']['amp-lightbox'] ) ) {
            $data['amp_component_scripts']['amp-lightbox'] = 'https://cdn.ampproject.org/v0/amp-lightbox-0.1.js';
          }
  }  
  return $data;
} 

// Form submission code start here
add_action('wp_ajax_optin_form_submission','optin_form_submission');
add_action('wp_ajax_nopriv_optin_form_submission','optin_form_submission');

function optin_form_submission (){
    $form_id = $_POST['ampforwp_form_id'];
    unset($_POST['ampforwp_form_id']);
    // foreach ($_POST as $key => $value) { 
    //   $key_and_value   .= ''.$key.'='.$value.'&';
    // }
    //$key  = rtrim($key_and_value,"&"); 
    $key = http_build_query($_POST);
    $form_num = get_post_meta( $form_id, 'amp_optin_select_form_company', true );

      switch ($form_num) {
          case '1':
                    $form_url = get_post_meta( $form_id, 'amp_optin_form_1_API_URL', true ); 
                     break;
          case '2':
                    $form_url = "https://app.getresponse.com/add_subscriber.html"; 
                    break;
          case '3':
                    $form_3_feild_one  = get_post_meta( $form_id, 'amp_optin_form_3_feild_one', true );
                    $form_3_feild_two  = get_post_meta( $form_id, 'amp_optin_form_3_feild_two', true );

                    $form_url = "https://". $form_3_feild_two .".createsend.com/t/d/s/". $form_3_feild_one .""; 
                    break;
          case '4':
                    $form_url = get_post_meta( $form_id, 'amp_optin_form_4_feild_one', true );
                    break;
          case '5':
                    $form_url = get_post_meta( $form_id, 'amp_optin_form_5_API_URL', true );
                    break;
          case '6':
                    $form_url = get_post_meta( $form_id, 'amp_optin_form_6_URL', true );
                      break;
          case '7': 
                    $list_id_form_7  = get_post_meta( $form_id, 'amp_optin_form_7_LIST_ID', true );
                    $form_url = "https://app.convertkit.com/forms/". $list_id_form_7 ."/subscriptions";
                      break;
          case '9':
                    $form_url = "https://www.rdstation.com.br/api/1.2/conversions";
                      break;                         
          case '13':
                    $form_url = get_post_meta($form_id, 'amp_optin_form_13_mautic_url',true );
                      break;
          case '15':
                    $form_url ="https://forms.ontraport.com/v2.4/form_processor.php?";
                      break;
         case '17':
                    $form_url = get_post_meta( $form_id, 'amp_optin_form_17_form_URL', true ); 
                      break;
         case '19':
                    $form_url = get_post_meta( $form_id, 'amp_optin_form_19_form_action', true );
                      break; 
          case '20':
                     $form_url = get_post_meta( $form_id, 'amp_optin_form_20_form_url', true );
                      break;
          case '24':
                     $form_url ="//sg-autorepondeur.com/public/subscribe.php";
                      break;
          case '26':
                    $form_url = get_post_meta( $form_id, 'amp_optin_form_26_API_URL', true ); 
                     break;
          
      }
$cookie="sdcookie.txt";
$curl = curl_init();
$curlopt_url = '';
if($form_num == '7'){
    $curlopt_url = $form_url.'?'.$key;
}
else{ 
    $curlopt_url = $form_url;
}
// $curl_array = array( 
//                 CURLOPT_RETURNTRANSFER => true,
//                 CURLOPT_URL => $curlopt_url,
//                 CURLOPT_HEADER => 0,
//                 CURLOPT_ENCODING => "",
//                 CURLOPT_SSL_VERIFYPEER => false,
//                 CURLOPT_COOKIEJAR => $cookie,
//                 CURLOPT_COOKIEFILE => $cookie,
//                 CURLOPT_MAXREDIRS => 10,
//                 CURLOPT_TIMEOUT => 30,
//                 CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
//                 CURLOPT_FOLLOWLOCATION => 1,
//                 CURLOPT_CUSTOMREQUEST => "POST",
//                 CURLOPT_POSTFIELDS => $key,
//                 CURLOPT_HTTPHEADER => array(
//                   "cache-control: no-cache",
//                   "content-type: application/x-www-form-urlencoded",
//                 ),
//               ); 
//   curl_setopt_array($curl,$curl_array);
//   $response = curl_exec($curl);
//   $err = curl_error($curl);
//   $redirectURL = curl_getinfo($curl );
//   curl_close($curl);  
//   $amp_optin_Site = '';
//   if ($err) {
//     echo "cURL Error #:" . $err;
//   } else {
//     $siteUrl = parse_url(
//       get_site_url()
//     );
//     $amp_optin_Site = $siteUrl['scheme'] . '://' . $siteUrl['host'];
//   }
//   if( is_array($redirectURL) ) {
//     $redirect_check = get_post_meta($form_id, 'amp_optin_checkbox_redirect', true);
//     if($redirect_check == true){
//       $redirect_url = get_post_meta( $form_id, 'ampforwp_optin_redirection', true );
//     } 
//      if( empty($redirect_url))
//         {
//             header('AMP-Access-Control-Allow-Source-Origin: '.$amp_optin_Site.'');
//         }
//         else
//         {
//           header('AMP-Access-Control-Allow-Source-Origin: '.$amp_optin_Site.'');
//           header("AMP-Redirect-To: ".$redirect_url);
//           header("Access-Control-Expose-Headers: AMP-Redirect-To, AMP-Access-Control-Allow-Source-Origin"); 
//         }
//       echo json_encode(array('successmsg'=>$_POST['name'].'Optin Form submit successfull.'));
//       die();
//   } 
//   die;

//checking nonce.
  if(!wp_verify_nonce($_POST['amp_optin_nonce'],'amp_optin_nonce') && ((!strpos($_SERVER['HTTP_ORIGIN'], 'cdn.ampproject.org')) && (!strpos($_SERVER['HTTP_ORIGIN'], 'amp.cloudflare.com')) && (!strpos($_SERVER['HTTP_REFERER'], 'google.com/amp/s/')) ) ){
          header('HTTP/1.1 500 FORBIDDEN');
          echo wp_json_encode( 'Sorry, your nonce did not verify.' );
          die;
  }

 $response = wp_remote_post(
              $curlopt_url,
              array(
                  'body' => $key
              )
          );

    if ( is_wp_error( $response ) ) {
      wp_remote_retrieve_body( $response );
       echo json_encode(array('error_message'=>$response ));
    }else{

        $redirect_check = get_post_meta($form_id, 'amp_optin_checkbox_redirect', true);
        if($redirect_check == true){
          $redirect_url = get_post_meta( $form_id, 'ampforwp_optin_redirection', true );
        } 

        if( empty($redirect_url)){
                header('AMP-Access-Control-Allow-Source-Origin: '.$amp_optin_Site.'');
              // form was not working through cdn.
                header('Access-Control-Allow-Origin: ' . $_SERVER['HTTP_ORIGIN']);
                header('Access-Control-Allow-Credentials: true');
        }
        else{
              header('AMP-Access-Control-Allow-Source-Origin: '.$amp_optin_Site.'');
              header("AMP-Redirect-To: ".$redirect_url);
              header("Access-Control-Expose-Headers: AMP-Redirect-To, AMP-Access-Control-Allow-Source-Origin"); 
        }
          echo json_encode(array('successmsg'=>'Form submit successfull.'));
           die();
    }
}

//Adding EDD_SL_Plugin_Updater file for update
require_once dirname( __FILE__ ) . '/updater/EDD_SL_Plugin_Updater.php';     
function ampforwp_optin_updater(){
   // retrieve our license key from the DB
  //$license_key = trim( get_option( 'amp_ads_license_key' ) );
        $selectedOption = get_option('redux_builder_amp',true);
        $license_key = '';//trim( get_option( 'amp_ads_license_key' ) );
        $pluginItemName = '';
        $pluginItemStoreUrl = '';
        $pluginstatus = '';
    if( isset($selectedOption['amp-license']) && "" != $selectedOption['amp-license'] && isset($selectedOption['amp-license'][AMP_OPTIN_ITEM_FOLDER_NAME])){
       $pluginsDetail = $selectedOption['amp-license'][AMP_OPTIN_ITEM_FOLDER_NAME];
       $license_key = $pluginsDetail['license'];
       //$pluginItemName = $pluginsDetail['item_name'];
       $pluginItemStoreUrl = $pluginsDetail['store_url'];
       $pluginstatus = $pluginsDetail['status'];

} 
// setup the updater
  $edd_updater = new Amp_Optin_Data_EDD_SL_Plugin_Updater( AMP_OPTIN_DATA_STORE_URL, __FILE__, array(
      'version'   => AMP_OPTIN_DATA_VERSION,      // current version number
      'license'   => $license_key,             // license key (used get_option above to retrieve from DB)
      'license_status'=>$pluginstatus,
      'item_name' => AMP_OPTIN_DATA_ITEM_NAME,      // name of this plugin
      'author'  => 'Mohammed Kaludi',           // author of this plugin
      'beta'    => false,
    )
  );      
}
add_action( 'admin_init', 'ampforwp_optin_updater', 0);
// Notice to enter license key once activate the plugin
$path = plugin_basename( __FILE__ );
  add_action("after_plugin_row_{$path}", function( $plugin_file, $plugin_data, $status ) {
    global $redux_builder_amp;
    if(! defined('AMP_OPTIN_ITEM_FOLDER_NAME')){
    $folderName = basename(__DIR__);
            define( 'AMP_OPTIN_ITEM_FOLDER_NAME', $folderName );
        }
        $pluginstatus= '';
        if(isset($redux_builder_amp['amp-license'][AMP_OPTIN_ITEM_FOLDER_NAME])){
        $pluginsDetail = $redux_builder_amp['amp-license'][AMP_OPTIN_ITEM_FOLDER_NAME];
        $pluginstatus = $pluginsDetail['status'];
      }
        if(empty($redux_builder_amp['amp-license'][AMP_OPTIN_ITEM_FOLDER_NAME]['license'])){
      echo "<tr class='active'><td>&nbsp;</td><td colspan='2'><a href='".esc_url(  self_admin_url( 'admin.php?page=amp_options&tabid=opt-go-premium' )  )."'>Please enter the license key</a> to get the <strong>latest features</strong> and <strong>stable updates</strong></td></tr>";
         }elseif($pluginstatus=="valid"){
          $update_cache = get_site_transient( 'update_plugins' );
            $update_cache = is_object( $update_cache ) ? $update_cache : new stdClass();
            if(isset($update_cache->response[ AMP_OPTIN_ITEM_FOLDER_NAME ]) 
                && empty($update_cache->response[ AMP_OPTIN_ITEM_FOLDER_NAME ]->download_link) 
             ){
               unset($update_cache->response[ AMP_OPTIN_ITEM_FOLDER_NAME ]);
            }
            set_site_transient( 'update_plugins', $update_cache );
            
        }
    }, 10, 3 );

