<?php
/* Template Name: Home Page */
get_header();
if ( have_posts() ) {
    while ( have_posts() ) { the_post();?>
        <div class="banner-main">
            <div class="banner-inner" style="background: url(<?php echo get_the_post_thumbnail_url();?>); background-repeat: no-repeat; background-size: cover;">
                <div class="banner-content wow fadeInUp">
                    <div class="container container-2">
                        <?php
                        if(get_field('h1')) { ?>
                            <div class="banner-text">
                                <h1 class="text-noeffect">
                                    <figure><?php the_field('h1');?></figure>
                                </h1>
                            </div>
                        <?php
                        }?>
                        <?php
                        if(get_field('request_consultation')) { ?>
                            <div class="banner-btn"><a href="<?php echo get_field('request_consultation')['url'];?>"><?php echo get_field('request_consultation')['title'];?></a></div>
                        <?php
                        }?>
                    </div>
                </div>
            </div>
        </div>
        <div class="middle-content">
            <div class="home-pa-main">
                <div class="container container-2">
                    <div class="row">
                        <div class="col-sm-3 col-xs-12">
                            <div class="hpa-left">
                                <div class="hpa-left-tl">
                                    <h2 class="text-noeffect"><?php the_field('practice_title_1');?>
                                        <summary><?php the_field('practice_title_2');?></summary>
                                    </h2>
                                </div>
                                <?php the_field('practice_content');?>
                                <div class="hpa-left-btn"><a href="<?php the_field('hpa_left_btn_link');?>"><i class="fa fa-long-arrow-right"></i></a></div>
                            </div>
                        </div>
                        <?php
                        $posts_rel = get_field('select_practice_areas');
                        if( $posts_rel ){ ?>
                        <div class="col-sm-9 col-xs-12">
                            <div class="hpa-right">
                                <?php
                                foreach( $posts_rel as $post) {  setup_postdata($post); ?>
                                    <div <?php post_class(['hpa-box']);?>>
                                        <a href="<?php the_permalink();?>" title="<?php the_field('menu_title');?>">
                                            <img src="<?php the_field('practice_image');?>" alt="<?php the_field('menu_title');?>">
                                            <div class="hpa-box-name"><?php the_field('menu_title');?></div>
                                        </a>
                                    </div>
                                <?php
                                } wp_reset_postdata();?>
                            </div>
                        </div>
                        <?php
                        } ?>
                    </div>
                </div>
            </div>
            <div class="default-section text-center">
                <div class="container container-2 wow fadeInUp">
                    <?php
                    if(get_field('welcome_title')) { ?>
                        <div class="dc-tl">
                            <h2 class="text-noeffect"><?php the_field('welcome_title');?></h2>
                        </div>
                    <?php
                    }
                    the_content(); ?>
                </div>
            </div>
            <div class="home-equipped">
                <div class="container container-2">
                    <?php
                    if(get_field('equipped_title')) { ?>
                        <div class="dc-tl">
                            <h2 class="text-noeffect"><?php the_field('equipped_title');?></h2>
                        </div>
                    <?php
                    } ?>
                    <div class="row">
                        <div class="col-sm-6 col-xs-12">
                            <?php the_field('equipped_left_content');?>
                        </div>
                        <div class="col-sm-6 col-xs-12">
                            <?php the_field('equipped_right_content');?>
                            <?php
                            if(get_field('equipped_right_content_blue')) { ?>
                                <div class="blue-right">
                                    <?php the_field('equipped_right_content_blue');?>
                                </div>
                            <?php
                            } ?>
                        </div>
                    </div>
                </div>
            </div>
            <div class="home-video-main">
                <div class="container container-2">
                    <div class="row">
                        <div class="col-sm-6 col-xs-12">
                            <div class="hv-left">
                                <?php
                                if(get_field('attorney_title')) { ?>
                                    <div class="hvl-tl">
                                        <h2 class="text-noeffect"><?php the_field('attorney_title');?></h2>
                                    </div>
                                <?php
                                }?>
                                <div class="hv-btn"><a href="<?php echo get_field('meet_attorney')['url'];?>" class="btn-design"><?php echo get_field('meet_attorney')['title'];?></a></div>
                            </div>
                        </div>
                        <div class="col-sm-6 col-xs-12">
                            <div class="hv-right">
                                <?php
                                if(get_field('greg_title')) { ?>
                                    <div class="hvr-tl">
                                        <h2 class="text-noeffect"><?php the_field('greg_title');?></h2>
                                    </div>
                                <?php
                                } ?>
                                <div class="hvr-video">
                                    <video poster="<?php the_field('greg_video_image');?>" controls>
                                        <source src="<?php the_field('greg_video');?>" type="video/mp4">
                                    </video>
                                </div>
                                <div class="hv-btn"><a href="<?php echo get_field('greg_watch_video')['url'];?>" class="btn-design"><?php echo get_field('greg_watch_video')['title'];?></a></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            
              <style>
                
                .dis {
    color: #fff;
    text-align: center;
    margin: auto;
    display: block;
    position: relative;
    top: 30px;
}
            </style>
            <!--new--------------->
            
            <div class="home-why-doo default-section text-center">
            <div class="container">
			
                	<div class="sec-title">
               <p class="count1">Our Settlements</p></div>
                <div class="row">
                   <div class="col-lg-4 col-md-6 col-sm-6">
                        <div class="funFacts">
                            <div class="icon1">
                               <img src="https://findthelawyers.com/gproslaw/wp-content/uploads/2020/12/Motorcycle-accident-icons-1.png" alt="icon">
                            </div>
                            <div class="text2">
                                <p class="count1">$3,300,000 </p>
                              <div class="txt text-white"> Motorcycle Accident </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col-lg-4 col-md-6 col-sm-6">
                        <div class="funFacts">
                            <div class="icon1">
                              <img src="https://findthelawyers.com/gproslaw/wp-content/uploads/2020/12/truck-accident-icon-1.png" alt="icon">
                            </div>
                            <div class="text2">
                                <p class="count1">$1,250,000</p>
                                <div class="txt text-white">Truck Accident</div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col-lg-4 col-md-6 col-sm-6">
                        <div class="funFacts">
                            <div class="icon1">
                              <img src="https://findthelawyers.com/gproslaw/wp-content/uploads/2020/12/truck-trailer-accident-icon-1.png" alt="icon">
                            </div>
                            <div class="text2">
                                <p class="count1">$1,000,000</p>
                                <div class="txt text-white">Tractor Trailer Accident</div>
                            </div>
                        </div>
                    </div>
                    
					</div>
                    
                   <div class="row ptb-40"> 
                    
					<div class="col-lg-4 col-md-6 col-sm-6">
                        <div class="funFacts">
                            <div class="icon1">
                              <img src="https://findthelawyers.com/gproslaw/wp-content/uploads/2020/12/Motorcycle-accident-icons-1.png" alt="icon">
                            </div>
                            <div class="text2">
                                <p class="count1">$1,000,000</p>
                                <div class="txt text-white">Motorcycle Accident</div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col-lg-4 col-md-6 col-sm-6">
                        <div class="funFacts">
                            <div class="icon1">
                               <img src="https://findthelawyers.com/gproslaw/wp-content/uploads/2020/12/car-accident-icon-1.png" alt="icon">
                            </div>
                            <div class="text2">
                                <p class="count1">$250,000</p>
                               <div class="txt text-white">Car Accident</div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col-lg-4 col-md-6 col-sm-6">
                        <div class="funFacts">
                            <div class="icon1">
                               <img src="https://findthelawyers.com/gproslaw/wp-content/uploads/2020/12/slip-icon.png" alt="icon">
                            </div>
                            <div class="text2">
                                <p class="count1">$175,000</p>
                               <div class="txt text-white">Slip and Fall Injury</div>
                            </div>
                        </div>
                    </div>
                    
                </div>
                
                <div class="col-lg-12 col-md-12 col-sm-12">
                
                <p class="dis"><strong>ATTORNEY ADVERTISING DISCLAIMER:</strong> Prior results do not guarantee a similar result</p>
                
                </div>
                
            </div>
        </div>
            <div class="home-why-do default-section text-center">
                <div class="container container-2 wow fadeInUp">
                    <?php
                    if(get_field('lawyer_title')) { ?>
                        <div class="dc-tl">
                            <h2 class="text-noeffect"><?php the_field('lawyer_title');?></h2>
                        </div>
                    <?php
                    }
                    the_field('lawyer_content');
                     if( have_rows('award_logo_rep') ) { ?>
                        <div class="home-awards-main">
                             <?php
                             while ( have_rows('award_logo_rep') ) { the_row(); ?>
                                 <div class="ha-box"><img src="<?php echo get_sub_field('award_logo')['url'];?>" alt="<?php echo get_sub_field('award_logo')['alt'];?>"></div>
                             <?php
                             } reset_rows(); ?>
                        </div>
                     <?php
                     } ?>
                </div>
            </div>
            <div class="home-blog-main">
                <div class="container container-2">
                    <div class="dc-tl">
                        <h2 class="text-noeffect">
                            <figure><?php the_field('blog_title');?></figure>
                            <?php the_field('blog_sub_title');?>
                        </h2>
                    </div>
                    <?php
                    $myposts = get_posts(['post_type' => 'post', 'posts_per_page' => 3,]);
                    if( $myposts ){ ?>
                        <div class="home-blog-inner">
                            <div class="row">
                                <?php
                                $counter = 1;
                                foreach( $myposts as $post) {  setup_postdata($post); ?>
                                    <div class="col-sm-4 col-xs-12">
                                        <div class="h-blog-box">
                                            <div class="h-blog-box-inner">
                                                <div class="h-blog-name"><a href="<?php the_permalink();?>"><?php echo wp_trim_words( get_the_title(), $num_words = 15, $more = null ); ?></a>
                                                </div>
                                                <div class="h-blog-number"><?php echo str_pad($counter, 2, "0", STR_PAD_LEFT);?></div>
                                                <div class="h-blog-post-detais">
                                                    <figure><i class="fa fa-calendar"></i><?php echo get_the_date();?></figure>
                                                    <figure><i class="fa fa-user"></i><?php the_author(); ?></figure>
                                                </div>
                                                <div class="h-blog-post-content">
                                                    <?php the_excerpt(); ?>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                <?php
                                $counter++;
                                } wp_reset_postdata();?>
                            </div>
                            <div class="h-blog-btn"><a href="<?php echo get_permalink(get_option('page_for_posts'));?>" class="btn-design"><?php the_field('view_blog');?></a></div>
                        </div>
                    <?php
                    } ?>
                </div>
            </div>
        </div>
<?php
    }
}
get_footer(); ?>